=== debian/changelog ===
rabbitmq-server (3.12.1-1ubuntu1) noble; urgency=medium

  * SECURITY UPDATE: Denial of service
    - debian/patches/CVE-2023-46118-*.patch: Introduce HTTP request body limit
      for definition uploads and Reduce default HTTP API request body size limit
      to 10 MiB in deps/rabbitmq_management/Makefile, include/rabbit_mgmt.hrl,
      priv/schema/rabbitmq_management.schema, src/rabbit_mgmt_util.erl,
      src/rabbit_mgmt_wm_definitions.erl.
    - CVE-2023-46118

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Wed, 22 Nov 2023 16:07:37 -0300

rabbitmq-server (3.12.1-1) experimental; urgency=medium

  * New upstream release. 
  * d/p/*: Refresh. 
  * d/control: Bump minimum Erlang version to 25.0.
  * d/copyright: Tidy for new upstream release, fix stanza ordering.
  * d/source.lintian-overrides: Refresh overrides with correct match.
  * d/control: Drop Depends on lsb-base.
  * d/control: Bump Standards-Version to 4.6.2, no changes.

 -- James Page <james.page@ubuntu.com>  Tue, 18 Jul 2023 09:35:50 +0100
