=== debian/tests/control ===
Tests: smoke-test
Restrictions: superficial, isolation-container
